#include<fstream>
using namespace std;
int main()
{
	ifstream f("tongbangm.inp");
	ofstream g("tongbangm.out");
	static int n,m,i,a[1000000],j,k,t;
	f>>n>>m;
	for (i=0;i<n;i++) f>>a[i];
	for (i=0;i<n-2;i++)
		for (j=i+1;j<n-1;j++)
			for (k=j+1;k<n;k++)
				if (a[i]+a[j]+a[k]==m) 
					{
						g<<a[i]<<' '<<a[j]<<' '<<a[k]<<endl;
						t=1;	
					}
	if (t!=1) g<<'0';
	f.close();
	g.close();
	return 0;
}
